/**
 * Copyright 2010 FH Trier, Umwelt-Campus Birkenfeld
 * 
 * FH Trier, Umwelt-Campus Birkenfeld  
 * P.O. Box 1380
 * D-55761 Birkenfeld
 * GERMANY
 *
 * http://www.umwelt-campus.de
 *
 * Lizenziert unter der EUPL, Version 1.1 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * http://ec.europa.eu/idabc/eupl
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie ist",
 * OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
 
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package de.umweltcampus.uput.informatik.openeanvadapter.documents.generators;

import de.umweltcampus.uput.informatik.openeanvadapter.communication.zksservices.ZKSMessageUtil;
import de.umweltcampus.uput.informatik.openeanvadapter.documents.generators.containers.MessageDataContainer;
import de.umweltcampus.uput.informatik.openeanvadapter.documents.generators.containers.ZertifikatsuebermittlungDataContainer;
import uri.bmu_waste_interface.message.Nachricht.Nutzdaten;
import uri.bmu_waste_interface.zks.ZertifikatsuebermittlungTyp.BehoerdlicheNummerBtr;

/**
 *
 * @author Marc Beck
 */
public class ZertifikatsuebermittlungGenerator extends AbstractZKSMessageGenerator {

    @Override
    protected Nutzdaten generateNutzdaten(MessageDataContainer dataContainer) {
        ZertifikatsuebermittlungDataContainer container = (ZertifikatsuebermittlungDataContainer) dataContainer;
        uri.bmu_waste_interface.message.ObjectFactory messageObjectFactory = new uri.bmu_waste_interface.message.ObjectFactory();
        uri.bmu_waste_interface.message.Nachricht.Nutzdaten nutzdaten = messageObjectFactory.createNachrichtNutzdaten();
        //ZKS ObjectFactory
        uri.bmu_waste_interface.zks.ObjectFactory zksObjectFactory = new uri.bmu_waste_interface.zks.ObjectFactory();
        uri.bmu_waste_interface.zks.ZertifikatsuebermittlungTyp zertifikatsuebermittlungTyp = zksObjectFactory.createZertifikatsuebermittlungTyp();
        zertifikatsuebermittlungTyp.setSpezifikationsversion("1.04");
        //Behoerdliche Nummer
        BehoerdlicheNummerBtr behoerdlicheNummerBtr = zksObjectFactory.createZertifikatsuebermittlungTypBehoerdlicheNummerBtr();
        behoerdlicheNummerBtr.setATBRolle(container.getAtbRolle());
        behoerdlicheNummerBtr.setBehoerdlicheNr(container.getBehoerdlicheNummer());
        behoerdlicheNummerBtr.setPruefziffer(ZKSMessageUtil.getPruefziffer(container.getBehoerdlicheNummer()));
        zertifikatsuebermittlungTyp.setBehoerdlicheNummerBtr(behoerdlicheNummerBtr);
        //Zertifkat Alt
        zertifikatsuebermittlungTyp.setZertifikatAlt(container.getZertifikatAlt());
        //Zertifikat Neu
        zertifikatsuebermittlungTyp.setZertifikatNeu(container.getZertifikatNeu());
        //Bemerkung wenn vorhanden
        if (container.getBemerkung() != null) {
            zertifikatsuebermittlungTyp.setBemerkung(container.getBemerkung());
        }
        //Zertifikatsübermittlung erstellt!
        nutzdaten.setZertifikatsuebermittlung(zertifikatsuebermittlungTyp);
        return nutzdaten;
    }
}
